/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS */
(function (window, rJS, loopEventListener) {
  "use strict";

  function getParameterDict () {
    var hash = window.location.hash.substring(1),
      params = {};
    hash.split('&').map(hk => {
      let temp = hk.split('=');
      params[temp[0]] = temp[1];
    });
    return params;
  }

  function makeid(length) {
    var result           = '';
    var characters       = 'abcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for ( var i = 0; i < length; i++ ) {
      result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
  }

  function loadCribJSFromZipFile (gadget, event) {
    return RSVP.Queue()
    .push(function() {
      return gadget.getDeclaredGadget("jio_cribjs");
    })
    .push(function(jio_cribjs_gadget) {
      return jio_cribjs_gadget.loadFromZipFile({
        path: document.location.href,
        file_list: gadget.props.element.querySelector("form.crib-load-from-zip-file .load-zip-file").files,
        from_path: gadget.props.element.querySelector("form.crib-load-from-zip-file .load-from-zip-path").value,
        to_path: gadget.props.element.querySelector("form.crib-load-from-zip-file .load-zip-to-path").value,
        application_id: "cribjs"
      })
    })
    .push(function (url_list) {
      document.location = gadget.props.element.querySelector("form.crib-load-from-zip-file .redirect-url").value;
    })
    .push(console.log, console.log);
  }

  function loadCribJSFromZipUrl (gadget, event) {
    return RSVP.Queue()
    .push(function() {
      return gadget.getDeclaredGadget("jio_cribjs");
    })
    .push(function(jio_cribjs_gadget) {
      return jio_cribjs_gadget.loadFromZipUrl({
        path: document.location.href,
        zip_url: gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-url").value,
        from_path: gadget.props.element.querySelector("form.crib-load-from-zip-url .load-from-zip-path").value,
        to_path: gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-to-path").value,
        application_id: "cribjs"
      })
    })
    .push(function (url_list) {
      document.location = gadget.props.element.querySelector("form.crib-load-from-zip-url .redirect-url").value;
    })
    .push(console.log, console.log);
  }

  rJS(window)

    .declareMethod('render', function (options) {
    var gadget = this,
        getURL = window.location,
        site = getURL.protocol + "//" + getURL.host,
        params = getParameterDict(),
        edit_url="https://" + makeid(10) + ".cribjs.nexedi.net/crib-editor4/#page=editor&url="
    		+ site + "&crib_enable_url=" + site + "/crib-enable.html";
    gadget.props.element.querySelector("a.edit-url").href = edit_url ;
    if ( params.hasOwnProperty("from_path") ) {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-from-zip-path").value = params.from_path;
    } else {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-from-zip-path").value = "cribjs-master/";
    }
    if ( params.hasOwnProperty("to_path") ) {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-to-path").value = params.to_path;
    } else {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-to-path").value = site;
    }
    if ( params.hasOwnProperty("zip_url") ) {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-url").value = params.zip_url;
    } else {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .load-zip-url").value = "https://lab.nexedi.com/cedric.leninivin/cribjs/-/archive/master/cribjs-master.zip";
    }
    if ( params.hasOwnProperty("redirect_url") ) {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .redirect-url").value = params.redirect_url;
    } else {
      gadget.props.element.querySelector("form.crib-load-from-zip-url .redirect-url").value = site + "/crib-editor4/";
    }
    return RSVP.Queue()
      .push(function () {
        var promise_list = []
        promise_list.push(loopEventListener(
          gadget.props.element.querySelector("form.crib-load-from-zip-url"),
          'submit',
          false,
          function (event) {loadCribJSFromZipUrl(gadget, event)}
        ));
        promise_list.push(loopEventListener(
          gadget.props.element.querySelector("form.crib-load-from-zip-file"),
          'submit',
          false,
          function (event) {loadCribJSFromZipFile(gadget, event)}
        ));
        return RSVP.all(promise_list)
    })
    .fail(function(e){console.log(e)})
  })

    .ready(function (g) {
    g.props = {};
    return g.getElement()
      .push(function (element) {
      g.props.element = element;
    }).push(function() {
      g.render({})
    })
    ;

  });
}(window, rJS, loopEventListener));